function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { PropTypes, Component } from 'react';
import { Editor, getDefaultKeyBinding } from 'draft-js';

import tokenize from './tokenize';
import { noop } from './lib';

var BooleanQueryEditor = function (_Component) {
  _inherits(BooleanQueryEditor, _Component);

  function BooleanQueryEditor() {
    var _temp, _this, _ret;

    _classCallCheck(this, BooleanQueryEditor);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.queryState = null, _this.focus = function () {
      var _this2;

      return (_this2 = _this).__focus__REACT_HOT_LOADER__.apply(_this2, arguments);
    }, _this.blur = function () {
      var _this3;

      return (_this3 = _this).__blur__REACT_HOT_LOADER__.apply(_this3, arguments);
    }, _this.getTermRange = function () {
      var _this4;

      return (_this4 = _this).__getTermRange__REACT_HOT_LOADER__.apply(_this4, arguments);
    }, _this.getQueryState = function () {
      var _this5;

      return (_this5 = _this).__getQueryState__REACT_HOT_LOADER__.apply(_this5, arguments);
    }, _this.onChange = function () {
      var _this6;

      return (_this6 = _this).__onChange__REACT_HOT_LOADER__.apply(_this6, arguments);
    }, _this.onBlur = function () {
      var _this7;

      return (_this7 = _this).__onBlur__REACT_HOT_LOADER__.apply(_this7, arguments);
    }, _this.onFocus = function () {
      var _this8;

      return (_this8 = _this).__onFocus__REACT_HOT_LOADER__.apply(_this8, arguments);
    }, _this.onEscape = function () {
      var _this9;

      return (_this9 = _this).__onEscape__REACT_HOT_LOADER__.apply(_this9, arguments);
    }, _this.onArrow = function () {
      var _this10;

      return (_this10 = _this).__onArrow__REACT_HOT_LOADER__.apply(_this10, arguments);
    }, _this.onUpArrow = function () {
      var _this11;

      return (_this11 = _this).__onUpArrow__REACT_HOT_LOADER__.apply(_this11, arguments);
    }, _this.onDownArrow = function () {
      var _this12;

      return (_this12 = _this).__onDownArrow__REACT_HOT_LOADER__.apply(_this12, arguments);
    }, _this.onTab = function () {
      var _this13;

      return (_this13 = _this).__onTab__REACT_HOT_LOADER__.apply(_this13, arguments);
    }, _this.handleReturn = function () {
      var _this14;

      return (_this14 = _this).__handleReturn__REACT_HOT_LOADER__.apply(_this14, arguments);
    }, _this.handlePastedText = function () {
      var _this15;

      return (_this15 = _this).__handlePastedText__REACT_HOT_LOADER__.apply(_this15, arguments);
    }, _this.handleKeyCommand = function () {
      var _this16;

      return (_this16 = _this).__handleKeyCommand__REACT_HOT_LOADER__.apply(_this16, arguments);
    }, _this.keyBindingFn = function () {
      var _this17;

      return (_this17 = _this).__keyBindingFn__REACT_HOT_LOADER__.apply(_this17, arguments);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  BooleanQueryEditor.prototype.__focus__REACT_HOT_LOADER__ = function __focus__REACT_HOT_LOADER__() {
    this.ref.focus();
  };

  BooleanQueryEditor.prototype.__blur__REACT_HOT_LOADER__ = function __blur__REACT_HOT_LOADER__() {
    this.ref.blur();
  };

  BooleanQueryEditor.prototype.__getTermRange__REACT_HOT_LOADER__ = function __getTermRange__REACT_HOT_LOADER__() {
    var selection = window.getSelection();

    if (selection.rangeCount === 0) {
      return null;
    }

    var range = selection.getRangeAt(0);
    var text = range.startContainer.textContent.trim();
    var end = range.startOffset;
    var start = end - text.length;

    return { start: start, end: end, text: text };
  };

  BooleanQueryEditor.prototype.__getQueryState__REACT_HOT_LOADER__ = function __getQueryState__REACT_HOT_LOADER__() {
    var textRange = this.getTermRange();

    if (textRange === null || textRange !== null && textRange.start < 0) {
      return null;
    }

    var tempRange = window.getSelection().getRangeAt(0).cloneRange();
    var startOffset = Math.max(textRange.start, 0);
    tempRange.setStart(tempRange.startContainer, startOffset);
    var rangeRect = tempRange.getBoundingClientRect();
    var text = textRange.text;

    var _tokenize = tokenize(text),
        token = _tokenize[0];

    this.queryState = {
      text: text,
      token: token,
      top: rangeRect.bottom,
      left: rangeRect.left,
      selectedIndex: 0
    };

    return this.queryState;
  };

  BooleanQueryEditor.prototype.__onChange__REACT_HOT_LOADER__ = function __onChange__REACT_HOT_LOADER__(editorState) {
    var _this18 = this;

    this.props.onChange(editorState);

    window.requestAnimationFrame(function () {
      _this18.queryState = _this18.getQueryState();
      _this18.props.onQueryChange(_this18.queryState);
    });
  };

  BooleanQueryEditor.prototype.__onBlur__REACT_HOT_LOADER__ = function __onBlur__REACT_HOT_LOADER__(e) {
    this.props.onBlur(e);
  };

  BooleanQueryEditor.prototype.__onFocus__REACT_HOT_LOADER__ = function __onFocus__REACT_HOT_LOADER__(e) {
    this.props.onFocus(e);
  };

  BooleanQueryEditor.prototype.__onEscape__REACT_HOT_LOADER__ = function __onEscape__REACT_HOT_LOADER__(e) {
    if (this.queryState === null) {
      this.props.onEscape(e);

      return 'not-handled';
    }

    e.preventDefault();
    this.queryState = null;
    this.props.onQueryChange(this.queryState);

    return 'handled';
  };

  BooleanQueryEditor.prototype.__onArrow__REACT_HOT_LOADER__ = function __onArrow__REACT_HOT_LOADER__(e, originalEvent, step) {
    if (this.queryState === null) {
      originalEvent(e);

      return 'handled';
    }

    e.preventDefault();
    this.queryState.selectedIndex += step;
    this.props.onQueryChange(this.queryState);

    return 'handled';
  };

  BooleanQueryEditor.prototype.__onUpArrow__REACT_HOT_LOADER__ = function __onUpArrow__REACT_HOT_LOADER__(e) {
    return this.onArrow(e, this.props.onUpArrow, -1);
  };

  BooleanQueryEditor.prototype.__onDownArrow__REACT_HOT_LOADER__ = function __onDownArrow__REACT_HOT_LOADER__(e) {
    return this.onArrow(e, this.props.onDownArrow, 1);
  };

  BooleanQueryEditor.prototype.__onTab__REACT_HOT_LOADER__ = function __onTab__REACT_HOT_LOADER__(e) {
    return this.props.onTab(e);
  };

  BooleanQueryEditor.prototype.__handleReturn__REACT_HOT_LOADER__ = function __handleReturn__REACT_HOT_LOADER__(e) {
    e.preventDefault();

    if (this.queryState) {
      var _queryState = this.queryState,
          text = _queryState.text,
          selectedIndex = _queryState.selectedIndex;

      var content = this.props.editorState.getCurrentContent();
      var selection = content.getSelectionAfter();
      var entitySelection = selection.set('anchorOffset', selection.getFocusOffset() - text.length);

      this.queryState = null;
      this.props.onQueryChange(this.queryState);
      this.props.handleQueryReturn(text, selectedIndex, entitySelection);
    }

    return 'handled';
  };

  BooleanQueryEditor.prototype.__handlePastedText__REACT_HOT_LOADER__ = function __handlePastedText__REACT_HOT_LOADER__(text, html, editorState) {
    return this.props.handlePastedText(text, html, editorState);
  };

  BooleanQueryEditor.prototype.__handleKeyCommand__REACT_HOT_LOADER__ = function __handleKeyCommand__REACT_HOT_LOADER__(command) {
    return this.props.handleKeyCommand(command);
  };

  BooleanQueryEditor.prototype.__keyBindingFn__REACT_HOT_LOADER__ = function __keyBindingFn__REACT_HOT_LOADER__(e) {
    return this.props.keyBindingFn(e) || getDefaultKeyBinding(e);
  };

  BooleanQueryEditor.prototype.render = function render() {
    var _this19 = this;

    var editorState = this.props.editorState;


    return React.createElement(Editor, {
      ref: function ref(_ref) {
        _this19.ref = _ref;
      },
      editorState: editorState,
      onChange: this.onChange,
      onBlur: this.onBlur,
      onFocus: this.onFocus,
      onEscape: this.onEscape,
      onUpArrow: this.onUpArrow,
      onDownArrow: this.onDownArrow,
      onTab: this.onTab,
      handleReturn: this.handleReturn,
      handlePastedText: this.handlePastedText,
      handleKeyCommand: this.handleKeyCommand,
      keyBindingFn: this.keyBindingFn
    });
  };

  return BooleanQueryEditor;
}(Component);

BooleanQueryEditor.propTypes = {
  editorState: PropTypes.object.isRequired,
  onChange: PropTypes.func,
  onBlur: PropTypes.func,
  onFocus: PropTypes.func,
  onEscape: PropTypes.func,
  onUpArrow: PropTypes.func,
  onDownArrow: PropTypes.func,
  onTab: PropTypes.func,
  onQueryChange: PropTypes.func,
  handleReturn: PropTypes.func,
  handleQueryReturn: PropTypes.func,
  handlePastedText: PropTypes.func,
  handleKeyCommand: PropTypes.func,
  keyBindingFn: PropTypes.func
};
BooleanQueryEditor.defaultProps = {
  onChange: noop,
  onBlur: noop,
  onFocus: noop,
  onEscape: noop,
  onUpArrow: noop,
  onDownArrow: noop,
  onQueryChange: noop,
  onTab: noop,
  handleReturn: noop,
  handleQueryReturn: noop,
  handlePastedText: noop,
  handleKeyCommand: noop,
  keyBindingFn: noop
};
var _default = BooleanQueryEditor;


export default _default;
;

var _temp2 = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(BooleanQueryEditor, 'BooleanQueryEditor', 'src/BooleanQueryEditor.jsx');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/BooleanQueryEditor.jsx');
}();

;