function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

import React from 'react';
import Immutable from 'immutable';
import tokenize from './tokenize';

function occupySlice(targetArr, start, end, componentKey) {
  for (var ii = start; ii < end; ii++) {
    targetArr[ii] = componentKey;
  }
}

var BooleanDecorator = function () {
  function BooleanDecorator() {
    var _this = this;

    _classCallCheck(this, BooleanDecorator);

    this.highlighted = {};

    this.getDecorations = function () {
      return _this.__getDecorations__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.getComponentForKey = function () {
      return _this.__getComponentForKey__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    this.getPropsForKey = function () {
      return _this.__getPropsForKey__REACT_HOT_LOADER__.apply(_this, arguments);
    };
  }

  BooleanDecorator.prototype.__getDecorations__REACT_HOT_LOADER__ = function __getDecorations__REACT_HOT_LOADER__(block) {
    var _this2 = this;

    var blockKey = block.getKey();
    var blockText = block.getText();
    var decorations = new Array(blockText.length).fill(null);
    var tokens = tokenize(blockText);
    var offset = 0;

    this.highlighted[blockKey] = {};

    tokens.forEach(function (token) {
      if (typeof token === 'string') {
        offset += token.length;
      } else {
        var tokenId = 'tok' + offset;
        var resultId = blockKey + '-' + tokenId;

        _this2.highlighted[blockKey][tokenId] = token;

        occupySlice(decorations, offset, offset + token.content.length, resultId);
        offset += token.content.length;
      }
    });

    return Immutable.List(decorations);
  };

  BooleanDecorator.prototype.__getComponentForKey__REACT_HOT_LOADER__ = function __getComponentForKey__REACT_HOT_LOADER__() {
    return function (_ref) {
      var type = _ref.type,
          children = _ref.children;

      var props = {
        className: 'prism-token token ' + type
      };

      return React.createElement('span', props, children);
    };
  };

  BooleanDecorator.prototype.__getPropsForKey__REACT_HOT_LOADER__ = function __getPropsForKey__REACT_HOT_LOADER__(key) {
    var parts = key.split('-');
    var blockKey = parts[0];
    var tokId = parts[1];
    var token = this.highlighted[blockKey][tokId];

    return {
      type: token.type
    };
  };

  return BooleanDecorator;
}();

var _default = BooleanDecorator;


export default _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(occupySlice, 'occupySlice', 'src/boolean-decorator.js');

  __REACT_HOT_LOADER__.register(BooleanDecorator, 'BooleanDecorator', 'src/boolean-decorator.js');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/boolean-decorator.js');
}();

;